// ========================================================================================
//    BJ Printer Setup Utility Program
//    DOS Base
//    BJ Printer (such as the BJC-4100 and BJC-210)
//
//    1. Version 1.00 [August 18, '95]       : Tsukasa Jackie AIBA    : created new
//    2. Version 1.01 [September 21, '95]    : Tsukasa Jackie AIBA    : added A240
//    3. Version 1.02 [September 26, '95]    : Tsukasa Jackie AIBA    : added mono display
//    4. Version 1.03 [March 12, '96]        : Tsukasa Jackie AIBA    : added MultiPASS C2500
//    5. Version 1.10 [April 30, '96]        : Tsukasa Jackie AIBA    : Added BJC-80/240/4200/4550
//    6. Version 1.11 [May 15, 1996]         : Srinivas Krishnamurti  : Added new structure to take out TestPrint option for B380IFs
//    7. Version 1.11 [June 5, 1996]         : Srinivas Krishnamurti  : Added back Test Pattern Print for B380IF without Demo Print Option
//
//    Copyright Canon Information Systems, Inc. 1995, 1996
// ========================================================================================

#include    "bjsetup.h"

// ***********************************************************************
//        define global character strings
// ***********************************************************************

#define    ERROR            " Error "
#define    ERROR_MOUSE      "\n Mouse driver is NOT found!"
#define    ERROR_FILE       "\n Access denied because the directory is FULL or\n the file exists and can NOT be overwritten!"
#define    ERROR_FILE2      "\n This file is NOT for BJ Setup Utility!"
#define    ERROR_FILE3      "\n No such file, directory or invalid drive!"
#define    ERROR_FILE4      "\n Permission denied!"
#define    ERROR_FILE5      "\n Invalid argument!"
#define    ERROR_FILE6      "\n Too many open files!"
#define    ERROR_HELP       "\n Unable to open help file!"
#define    ERROR_INIT       "\n A suitable file is NOT found!\n\n Please change the current directory or add a BJSETUP directory to the PATH.\n\n"
#define    ERROR_REDUCTION  "\n When 'Enable' is selected in 'Smoothing',\n 'Reduction' is cancelled.\n\n             Please set again."
static char *INITFAIL_MSG = "BJ Printer Setup Utility:  Unable to initialize display.";

// ***********************************************************************
// @Initialize (Preset Status)
// ***********************************************************************

static unsigned char    choice_US_LQ[WIN4_MENU][WIN4_MENU_W] = 
                        {
                                                    {" LQ emulation (LQ) "  },    //  0
                                                    {" Letter "             },    //  1
                                                    {" High Quality "       },    //  2
                                                    {" Disable "            },    //  3
                                                    {" Disable "            },    //  4
                                                    {" Courier "            },    //  5
                                                    {" 437 "                },    //  6
                                                    {" 11 inches "          },    //  7
                                                    {" Set 1 "              },    //  8
                                                    {" Disable "            },    //  9
                                                    {" Disable "            },    // 10
                                                    {" CR = CR "            },    // 11
                                                    {" LF = LF "            },    // 12
                                                    {" Disable "            },    // 13
                                                    {" U.S.A. "             },    // 14
                                                    {" LPT1 "               },    // 15
                                                    {" Roman "              },    // 16
                                                    {" 437 "                },    // 17
                                                    {" 22 inches "          },    // 18
                                                    {" Graphics "           },    // 19
                                                    {" Disable "            },    // 20
                                                    {" CR = CR "            },    // 21
                                                    {" BJC-240 "            },    // 22
                                                    {" LQ emulation (LQ) "  },    // 23 - 0
                                                    {" Letter "             },    // 24 - 1
                                                    {" High Quality "       },    // 25 - 2
                                                    {" Disable "            },    // 26 - 3
                                                    {" Disable "            },    // 27 - 4
                                                    {" Courier "            },    // 28 - 5
                                                    {" 437 "                },    // 29 - 6
                                                    {" 11 inches "          },    // 30 - 7
                                                    {" Set 1 "              },    // 31 - 8
                                                    {" Disable "            },    // 32 - 9
                                                    {" Disable "            },    // 33 - 10
                                                    {" CR = CR "            },    // 34 - 11
                                                    {" LF = LF "            },    // 35 - 12
                                                    {" Disable "            },    // 36 - 13
                                                    {" U.S.A. "             },    // 37 - 14
                                                    {" LPT1 "               },    // 38 - 15
                                                    {" Roman "              },    // 39 - 16
                                                    {" 437 "                },    // 40 - 17
                                                    {" 22 inches "          },    // 41 - 18
                                                    {" Graphics "           },    // 42 - 19
                                                    {" Disable "            },    // 43 - 20
                                                    {" CR = CR "            },    // 44 - 21
                                                    {" Disable "            },    // 45 Reduction
                                                    {" Disable "            },    // 46 New - AutoPowerOn
                                                    {" 3.0 mm "             },    // 47 New - BJ Top Margin
                                                    {" 8.5 mm "             },    // 48 New - LQ Top Margin
                                                    {" Disable "            },    // 49 New - BJ Font Lock
                                                    {" Disable "            }     // 50 New - LQ Font Lock
                        };

static unsigned char    choice_US_BJ[WIN4_MENU][WIN4_MENU_W] = 
                        {
                                                    {" Bubble Jet (BJ) "    },
                                                    {" Letter "             },
                                                    {" High Quality "       },
                                                    {" Disable "            },
                                                    {" Disable "            },
                                                    {" Courier "            },
                                                    {" 437 "                },
                                                    {" 11 inches "          },
                                                    {" Set 1 "              },
                                                    {" Disable "            },
                                                    {" Disable "            },
                                                    {" CR = CR "            },
                                                    {" LF = LF "            },
                                                    {" Disable "            },
                                                    {" U.S.A. "             },
                                                    {" LPT1 "               },
                                                    {" Roman "              },
                                                    {" 437 "                },
                                                    {" 22 inches "          },
                                                    {" Graphics "           },
                                                    {" Disable "            },
                                                    {" CR = CR "            },
                                                    {" BJC-240 "            },
                                                    {" Bubble Jet (BJ) "    },
                                                    {" Letter "             },
                                                    {" High Quality "       },
                                                    {" Disable "            },
                                                    {" Disable "            },
                                                    {" Courier "            },
                                                    {" 437 "                },
                                                    {" 11 inches "          },
                                                    {" Set 1 "              },
                                                    {" Disable "            },
                                                    {" Disable "            },
                                                    {" CR = CR "            },
                                                    {" LF = LF "            },
                                                    {" Disable "            },
                                                    {" U.S.A. "             },
                                                    {" LPT1 "               },
                                                    {" Roman "              },
                                                    {" 437 "                },
                                                    {" 22 inches "          },
                                                    {" Graphics "           },
                                                    {" Disable "            },
                                                    {" CR = CR "            },
                                                    {" Disable "            },
                                                    {" Disable "            },    // 46 New - AutoPowerOn
                                                    {" 3.0 mm "             },    // 47 New - BJ Top Margin
                                                    {" 8.5 mm "             },    // 48 New - LQ Top Margin
                                                    {" Disable "            },    // 49 New - BJ Font Lock
                                                    {" Disable "            }     // 50 New - LQ Font Lock
                        };

static unsigned char    choice_Eu_LQ[WIN4_MENU][WIN4_MENU_W] = 
                        {
                                                    {" LQ emulation (LQ) "  },
                                                    {" A4 "                 },
                                                    {" High Quality "       },
                                                    {" Disable "            },
                                                    {" Disable "            },
                                                    {" Courier "            },
                                                    {" 437 "                },
                                                    {" 12 inches "          },
                                                    {" Set 2 "              },
                                                    {" Disable "            },
                                                    {" Disable "            },
                                                    {" CR = CR "            },
                                                    {" LF = LF "            },
                                                    {" Disable "            },
                                                    {" U.S.A. "             },
                                                    {" LPT1 "               },
                                                    {" Roman "              },
                                                    {" 437 "                },
                                                    {" 22 inches "          },
                                                    {" Graphics "           },
                                                    {" Disable "            },
                                                    {" CR = CR "            },
                                                    {" BJC-240 "            },
                                                    {" LQ emulation (LQ) "  },
                                                    {" A4 "                 },
                                                    {" High Quality "       },
                                                    {" Disable "            },
                                                    {" Disable "            },
                                                    {" Courier "            },
                                                    {" 437 "                },
                                                    {" 12 inches "          },
                                                    {" Set 2 "              },
                                                    {" Disable "            },
                                                    {" Disable "            },
                                                    {" CR = CR "            },
                                                    {" LF = LF "            },
                                                    {" Disable "            },
                                                    {" U.S.A. "             },
                                                    {" LPT1 "               },
                                                    {" Roman "              },
                                                    {" 437 "                },
                                                    {" 22 inches "          },
                                                    {" Graphics "           },
                                                    {" Disable "            },
                                                    {" CR = CR "            },
                                                    {" Disable "            },
                                                    {" Disable "            },    // 46 New - AutoPowerOn
                                                    {" 3.0 mm "             },    // 47 New - BJ Top Margin
                                                    {" 8.5 mm "             },    // 48 New - LQ Top Margin
                                                    {" Disable "            },    // 49 New - BJ Font Lock
                                                    {" Disable "            }     // 50 New - LQ Font Lock
                        };

static unsigned char    choice_Eu_BJ[WIN4_MENU][WIN4_MENU_W] = 
                        {
                                                    {" Bubble Jet (BJ) "    },
                                                    {" A4 "                 },
                                                    {" High Quality "       },
                                                    {" Disable "            },
                                                    {" Disable "            },
                                                    {" Courier "            },
                                                    {" 850 "                },
                                                    {" 12 inches "          },
                                                    {" Set 2 "              },
                                                    {" Disable "            },
                                                    {" Disable "            },
                                                    {" CR = CR "            },
                                                    {" LF = LF "            },
                                                    {" Disable "            },
                                                    {" U.S.A. "             },
                                                    {" LPT1 "               },
                                                    {" Roman "              },
                                                    {" 437 "                },
                                                    {" 22 inches "          },
                                                    {" Graphics "           },
                                                    {" Disable "            },
                                                    {" CR = CR "            },
                                                    {" BJC-240 "            },
                                                    {" Bubble Jet (BJ) "    },
                                                    {" A4 "                 },
                                                    {" High Quality "       },
                                                    {" Disable "            },
                                                    {" Disable "            },
                                                    {" Courier "            },
                                                    {" 850 "                },
                                                    {" 12 inches "          },
                                                    {" Set 2 "              },
                                                    {" Disable "            },
                                                    {" Disable "            },
                                                    {" CR = CR "            },
                                                    {" LF = LF "            },
                                                    {" Disable "            },
                                                    {" U.S.A. "             },
                                                    {" LPT1 "               },
                                                    {" Roman "              },
                                                    {" 437 "                },
                                                    {" 22 inches "          },
                                                    {" Graphics "           },
                                                    {" Disable "            },
                                                    {" CR = CR "            },
                                                    {" Disable "            },
                                                    {" Disable "            },    // 46 New - AutoPowerOn
                                                    {" 3.0 mm "             },    // 47 New - BJ Top Margin
                                                    {" 8.5 mm "             },    // 48 New - LQ Top Margin
                                                    {" Disable "            },    // 49 New - BJ Font Lock
                                                    {" Disable "            }     // 50 New - LQ Font Lock
                        };

static unsigned char    choice_As_BJ[WIN4_MENU][WIN4_MENU_W] = 
                        {
                                                    {" Bubble Jet (BJ) "    },
                                                    {" A4 "                 },
                                                    {" High Quality "       },
                                                    {" Disable "            },
                                                    {" Disable "            },
                                                    {" Courier "            },
                                                    {" 437 "                },
                                                    {" 12 inches "          },
                                                    {" Set 2 "              },
                                                    {" Disable "            },
                                                    {" Disable "            },
                                                    {" CR = CR "            },
                                                    {" LF = LF "            },
                                                    {" Disable "            },
                                                    {" U.S.A. "             },
                                                    {" LPT1 "               },
                                                    {" Roman "              },
                                                    {" 437 "                },
                                                    {" 22 inches "          },
                                                    {" Graphics "           },
                                                    {" Disable "            },
                                                    {" CR = CR "            },
                                                    {" BJC-240 "            },
                                                    {" Bubble Jet (BJ) "    },
                                                    {" A4 "                 },
                                                    {" High Quality "       },
                                                    {" Disable "            },
                                                    {" Disable "            },
                                                    {" Courier "            },
                                                    {" 437 "                },
                                                    {" 12 inches "          },
                                                    {" Set 2 "              },
                                                    {" Disable "            },
                                                    {" Disable "            },
                                                    {" CR = CR "            },
                                                    {" LF = LF "            },
                                                    {" Disable "            },
                                                    {" U.S.A. "             },
                                                    {" LPT1 "               },
                                                    {" Roman "              },
                                                    {" 437 "                },
                                                    {" 22 inches "          },
                                                    {" Graphics "           },
                                                    {" Disable "            },
                                                    {" CR = CR "            },
                                                    {" Disable "            },
                                                    {" Disable "            },    // 46 New - AutoPowerOn
                                                    {" 3.0 mm "             },    // 47 New - BJ Top Margin
                                                    {" 8.5 mm "             },    // 48 New - LQ Top Margin
                                                    {" Disable "            },    // 49 New - BJ Font Lock
                                                    {" Disable "            }     // 50 New - LQ Font Lock
                        };

#define    choice_default        choice_US_LQ       // Default Setting //

//    Window 0 ---------------------------------------------------------------------------

#define    WINDOW_0            "  Canon BJ Printer Setup Utility  "

//    Window 1 ---------------------------------------------------------------------------

static struct frame_def    menu_bar[] = 
                           {
                                        { " Exit<F10> ",    MenuBar0,    EXIT_KEY    },
                                        { FRAME_END                                  },
                                        { " Status<F5> ",   MenuBar3,    STATUS_KEY  },
                                        { FRAME_END                                  },
                                        { " Send<F6> ",     MenuBar2,    SEND_KEY    },
                                        { FRAME_END                                  },
                                        { " Default<F7> ",  MenuBar4,    DEFAULT_KEY },
                                        { FRAME_END                                  },
                                        { " About<F8> ",    MenuBar1,    ABOUT_KEY   },
                                        { FRAME_END                                  },
                                        { " Help<F1> ",     MenuBar5,    HELP_USE_KEY},
                                        { FRAME_END                                  },
                                        { FRAME_END                                  }
                          };

#define MENU_0_T        " Exit this program "
#define MENU_0_OK        "\n   @fd2[ OK ]"
#define MENU_0_CA        "     @fd2[ Cancel ]  \n\n"

#define MENU_1_T        " About this program "
#define MENU_1_1          "\n              Canon BJ Printer Setup Utility             \n"
#define MENU_1_2            "               Version 1.10 [June 12, 1996]            \n\n"
#define MENU_1_3            " Copyright (c) 1995, 1996 Canon Information Systems, Inc.\n"
#define MENU_1_4            "            Copyright (c) 1995, 1996 Canon Inc.          \n"
#define MENU_1_5            "                    All Rights Reserved                  \n\n"
#define MENU_1_OK           "                           @f[ OK ]                      "

#define MENU_2_T        " Send Setting Parameters "
#define MENU_2_OK        "\n   @fd2[ OK ]"
#define MENU_2_CA        "       @fd2[ Cancel ]  \n\n"

#define MENU_3_T        " Printer's Status "
#define MENU_3_OK        "\n   @fd2[ OK ]"
#define MENU_3_CA        "    @fd2[ Cancel ]  \n\n"
static unsigned char    ErrorMsg[10][WIN4_MENU_W] = {
                                            {" Printer Time Out "},
                                            {" Not Used         "},
                                            {" Not Used         "},
                                            {" I/O Error        "},
                                            {" Printer Selected "},
                                            {" Out of Paper     "},
                                            {" Acknowledge      "},
                                            {" Printer NOT Busy "},
                                            {" Printer NO Error "}
                        };
#define MENU_3_OK2            "\n          @f[ OK ]          "
#define PRINTER_ERROR    " Please check your printer!! "

#define MENU_4_T        " Change to Default settings "
#define MENU_4_OK        "\n    @fd2[ OK ]"
#define MENU_4_CA        "         @fd2[ Cancel ]   \n\n"

#define MENU_5_T        " How to use Help "
#define MENU_5_1          "\n When F1 key is pressed or the right button is clicked,\n"
#define MENU_5_2            " help messages of selected field appear.               \n\n"
#define MENU_5_3            " When ESC key is pressed, this help exits.             \n\n"
#define MENU_5_OK           "                         @f[ OK ]                      "

//    Window 2 ---------------------------------------------------------------------------

#define WINDOW_2_TITLE    "Setting Mode"

#define WINDOW_2_5               "    Printer =%s\n"
#define WINDOW_2_5_MP            "Printer =%s\n"
#define WINDOW_2_5_C30           " Printer =%s\n"
#define WINDOW_2_4       "@fd2h22[ Printer...       Ctrl-P ]\n"
#define WINDOW_2_0       "@fd2h22[ Setting Mode...  Ctrl-M ]\n"
#define WINDOW_2_1       "@fd2h22[ Open File...     Ctrl-O ]\n"
#define WINDOW_2_2       "@fd2h22[ Save File...     Ctrl-S ]\n"
#define WINDOW_2_3       "@fd2h22[ Delete File...   Ctrl-D ]\n"

#define WINDOW_2_0_S0   " MultiPASS C2500"
#define WINDOW_2_0_S30  " MultiPASS C30 "
#define WINDOW_2_0_SIF  " CFX-B380IF "
#define WINDOW_2_0_S1   " BJC-4100 "
#define WINDOW_2_0_S2   " BJC-210 "
#define WINDOW_2_0_S3   " BJC-80 "
#define WINDOW_2_0_S4   " BJC-240 "
#define WINDOW_2_0_S5   " BJC-4200 "
#define WINDOW_2_0_S6   " BJC-4550 "

#define WINDOW_2_4_H    " Change Printer "
#define WINDOW_2_0_H    " Change Setting Mode "
#define WINDOW_2_1_H    " Read Parameters "
#define WINDOW_2_2_H    " Store Parameters "
#define WINDOW_2_3_H    " Delete a File "

#define WINDOW_2_1_O    " Select to open a Setting file "
#define WINDOW_2_2_S    " Select to save a Setting file "
#define WINDOW_2_3_D    " Select to delete a Setting file "

#define MENU_2_D_T      " Delete? "
#define MENU_2_D_F      "\n  %s\n"
#define MENU_2_D_OK     "\n        @fd2[ OK ]"
#define MENU_2_D_CA     "       @fd2[ Cancel ]    \n\n"

static struct slug_list win2_menu_printer[] = {
            {    "              BJC-4550",                       NULL,      NULL, PrinterSet,   98},
            {    "              BJC-4200",                       NULL,      NULL, PrinterSet,   97},
            {    "              BJC-240 ",                       NULL,      NULL, PrinterSet,   96},
////!T. 4/16/96            {    "              BJC-80  ",                       NULL,      NULL, PrinterSet,   95},
            {    "              BJC-210 ",                       NULL,      NULL, PrinterSet,   94},
            {    "              BJC-4100",                       NULL,      NULL, PrinterSet,   93},
            {    "       MultiPASS C2500",                       NULL,      NULL, PrinterSet,   92},
            {    "       MultiPASS C30  ",                       NULL,      NULL, PrinterSet,  190},
            {    "            CFX-B380IF",                       NULL,      NULL, PrinterSet,  191},
            {                        NULL,           " Printer Name ",      NULL, FNULL,         0}
};
#define     MAX_PRINTER            8           // Number of printer models w/o BJC-80

static struct slug_list win2_menu[] = {
            {    "     LQ emulation (LQ)",        " LQ mode setting ",      NULL, ModeSet,      90},
            {    "       Bubble Jet (BJ)",        " BJ mode setting ",      NULL, ModeSet,      91},
            {                        NULL,           " Setting Mode ",      NULL, FNULL,         0}
};

//    Window 3 ---------------------------------------------------------------------------

static struct slug_list ok_menu1[] = {
            {    "                    OK",       " Turn off printer ",      NULL, SelectDisplay,     P1A},
            {    "                Cancel",     " Cancel to turn off ",      NULL, SelectDisplay,     PNG},
            {                        NULL,              " Power Off ",      NULL, FNULL,               0}
};
static struct slug_list ok_menu2[] = {
            {    "                    OK",          " Reset printer ",      NULL, SelectDisplay,     P2A},
            {    "                Cancel",        " Cancel to reset ",      NULL, SelectDisplay,     PNG},
            {                        NULL,          " Reset Printer ",      NULL, FNULL,               0}
};
static struct slug_list ok_menu3[] = {
            {    "                    OK",            " Eject paper ",      NULL, SelectDisplay,     P3A},
            {    "                Cancel",        " Cancel to eject ",      NULL, SelectDisplay,     PNG},
            {                        NULL,             " Eject Page ",      NULL, FNULL,               0}
};
static struct slug_list ok_menu4[] = {
            {    "LQ Emulation mode (LQ)",            " Set LQ mode ",      NULL, SelectDisplay,     P4A},
            {    "  Bubble Jet mode (BJ)",            " Set BJ mode ",      NULL, SelectDisplay,     P4B},
            {    "   Automatic Selection",     " Set auto selection ",      NULL, SelectDisplay,     P4C},
            {    "                Cancel",     " Cancel to set mode ",      NULL, SelectDisplay,     PNG},
            {                        NULL,   " Printer Control Mode ",      NULL, FNULL,               0}
};
static struct slug_list ok_menu5[] = {
            {    "        Ripple Pattern",   " Print for characters ",      NULL, SelectDisplay,     P5A},
#if 0
            {    "                Test B",       " Print for Test B ",      NULL, SelectDisplay,     P5B},
            {    "                Test C",       " Print for Test C ",      NULL, SelectDisplay,     P5C},
#endif
            {    "         Demonstration",         " Print for demo ",      NULL, SelectDisplay,     P5D},
            {    "        Nozzle pattern",       " Print for nozzle ",      NULL, SelectDisplay,     P5E},
            {    "                Cancel",        " Cancel to print ",      NULL, SelectDisplay,     PNG},
            {                        NULL,     " Test Print Pattern ",      NULL, FNULL,               0}
};
// SK, 6/4/96 - to remove demo print option for MP B380IF
static struct slug_list ok_menu5_B380IF[] = {
            {    "        Ripple Pattern",   " Print for characters ",      NULL, SelectDisplay,     P5A},
#if 0
            {    "                Test B",       " Print for Test B ",      NULL, SelectDisplay,     P5B},
            {    "                Test C",       " Print for Test C ",      NULL, SelectDisplay,     P5C},
            {    "         Demonstration",         " Print for demo ",      NULL, SelectDisplay,     P5D},
#endif
            {    "        Nozzle pattern",       " Print for nozzle ",      NULL, SelectDisplay,     P5E},
            {    "                Cancel",        " Cancel to print ",      NULL, SelectDisplay,     PNG},
            {                        NULL,     " Test Print Pattern ",      NULL, FNULL,               0}
};
static struct slug_list ok_menu5_80[] = {
            {    "         Demonstration",         " Print for demo ",      NULL, SelectDisplay,     P5D},
            {    "        Nozzle pattern",       " Print for nozzle ",      NULL, SelectDisplay,     P5E},
            {    "                Cancel",        " Cancel to print ",      NULL, SelectDisplay,     PNG},
            {                        NULL,     " Test Print Pattern ",      NULL, FNULL,               0}
};
static struct slug_list ok_menu6[] = {
            {    "                    OK", " Print current settings ",      NULL, SelectDisplay,     P6A},
            {    "                Cancel",        " Cancel to print ",      NULL, SelectDisplay,     PNG},
            {                        NULL,         " Print Settings ",      NULL, FNULL,               0}
};
static struct slug_list ok_menu7[] = {
            {    "                    OK",    " Go replacement mode ",      NULL, SelectDisplay,     P7A},
            {    "                Cancel",       " Cancel to change ",      NULL, SelectDisplay,     PNG},
            {                        NULL,   " Change Ink Cartridge ",      NULL, FNULL,               0}
};
static struct slug_list ok_menu8[] = {
            {    "                    OK",       " Perform cleaning ",      NULL, SelectDisplay,     P8A},
            {    "                Cancel",        " Cancel to clean ",      NULL, SelectDisplay,     PNG},
            {                        NULL,         " Clean Ink Head ",      NULL, FNULL,               0}
};
static struct slug_list ok_menu8_80[] = {
            {    "       Normal cleaning",       " Perform cleaning ",      NULL, SelectDisplay,     P8A},
            {    "              Flashing",       " Perform flashing ",      NULL, SelectDisplay,     P8B},
            {    "                Cancel",        " Cancel to clean ",      NULL, SelectDisplay,     PNG},
            {                        NULL,         " Clean Ink Head ",      NULL, FNULL,               0}
};
static struct slug_list ok_menu9[] = {
            {    "      U.S.A. - LQ mode",  " Set to LQ mode in USA ",      NULL, SelectDisplay,     P9B},
            {    "      U.S.A. - BJ mode",  " Set to BJ mode in USA ",      NULL, SelectDisplay,     P9C},
            {    "      Europe - LQ mode",    " Set to LQ in Europe ",      NULL, SelectDisplay,     P9D},
            {    "      Europe - BJ mode",    " Set to BJ in Europe ",      NULL, SelectDisplay,     P9E},
            {    "        Asia - LQ mode", " Set to LQ mode in Asia ",      NULL, SelectDisplay,     P9D},
            {    "        Asia - BJ mode", " Set to BJ mode in Asia ",      NULL, SelectDisplay,     P9F},
            {    "                Cancel",   " Cancel to Initialize ",      NULL, SelectDisplay,     PNG},
            {                        NULL,          " Preset Status ",      NULL, FNULL,               0}
};
static struct slug_list ok_menu9_80[] = {
            {    "               Factory",    " Set to Factory mode ",      NULL, SelectDisplay,     P9A},
            {    "                Cancel",   " Cancel to Initialize ",      NULL, SelectDisplay,     PNG},
            {                        NULL,          " Preset Status ",      NULL, FNULL,               0}
};
static struct slug_list ok_menu0[] = {
            {    "         Dump mode On ",          " Set Dump mode ",      NULL, SelectDisplay,     P0A},
            {    "         Dump mode Off",        " Reset Dump mode ",      NULL, SelectDisplay,     P0A},
            {    "                Cancel",    " Cancel to set/reset ",      NULL, SelectDisplay,     PNG},
            {                        NULL,              " Dump Mode ",      NULL, FNULL,               0}
};

static struct slug_list win3_menu[] = {

            {    "@1.Power Off            ",       " Turn off printer ",    ok_menu1,    FNULL,      HE1},
            {    "@2.Reset Printer        ",          " Reset printer ",    ok_menu2,    FNULL,      HE2},
            {    "@3.Eject Page           ",            " Eject paper ",    ok_menu3,    FNULL,      HE3},
            {    "@4.Printer Control Mode ",    " Switch control mode ",    ok_menu4,    FNULL,      HE4},
            {    "@5.Printer Test Pattern ",     " Perform test print ",    ok_menu5,    FNULL,      HE5},
            {    "@6.Print Settings       ", " Print current settings ",    ok_menu6,    FNULL,      HE6},
            {    "@7.Change Ink Cartridge ",      " Change print head ",    ok_menu7,    FNULL,      HE7},
            {    "@8.Clean Ink Head       ",       " Perform cleaning ",    ok_menu8,    FNULL,      HE8},
            {    "@9.Preset Status        ",    " Initialize settings ",    ok_menu9,    FNULL,      HE9},
            {                          NULL,         " Printer Action ",        NULL,    FNULL,        0}
};
// for MP B380IF; removing test print option because of firmware problems - SK, 5/15/96
// correction - remove only demo print option, not the whole test print option - SK, 6/4/96
static struct slug_list win3_menu_B380IF[] = {

            {    "@1.Power Off            ",       " Turn off printer ",    ok_menu1,    FNULL,      HE1},
            {    "@2.Reset Printer        ",          " Reset printer ",    ok_menu2,    FNULL,      HE2},
            {    "@3.Eject Page           ",            " Eject paper ",    ok_menu3,    FNULL,      HE3},
            {    "@4.Printer Control Mode ",    " Switch control mode ",    ok_menu4,    FNULL,      HE4},
            {    "@5.Printer Test Pattern ",     " Perform test print ",    ok_menu5_B380IF,    FNULL,      HE5},
            {    "@6.Print Settings       ", " Print current settings ",    ok_menu6,    FNULL,      HE6},
            {    "@7.Change Ink Cartridge ",      " Change print head ",    ok_menu7,    FNULL,      HE7},
            {    "@8.Clean Ink Head       ",       " Perform cleaning ",    ok_menu8,    FNULL,      HE8},
            {    "@9.Preset Status        ",    " Initialize settings ",    ok_menu9,    FNULL,      HE9},
            {                          NULL,         " Printer Action ",        NULL,    FNULL,        0}
};
static struct slug_list win3_menu_4200[] = {

            {    "@1.Power Off            ",       " Turn off printer ",    ok_menu1,    FNULL,      HE1},
            {    "@2.Reset Printer        ",          " Reset printer ",    ok_menu2,    FNULL,      HE2},
            {    "@3.Eject Page           ",            " Eject paper ",    ok_menu3,    FNULL,      HE3},
            {    "@4.Printer Control Mode ",    " Switch control mode ",    ok_menu4,    FNULL,      HE4},
            {    "@5.Printer Test Pattern ",     " Perform test print ",    ok_menu5,    FNULL,      HE5},
            {    "@6.Print Settings       ", " Print current settings ",    ok_menu6,    FNULL,      HE6},
            {    "@7.Change Ink Cartridge ",      " Change print head ",    ok_menu7,    FNULL,      HE7},
            {    "@8.Clean Ink Head       ",       " Perform cleaning ",    ok_menu8,    FNULL,      HE8},
            {    "@9.Preset Status        ",    " Initialize settings ",    ok_menu9,    FNULL,      HE9},
            {    "@0.Dump Mode            ",    " Set/Reset Dump mode ",    ok_menu0,    FNULL,      HE0},
            {                          NULL,         " Printer Action ",        NULL,    FNULL,        0}
};
static struct slug_list win3_menu_210[] = {

            {    "@1.Power Off            ",       " Turn off printer ",    ok_menu1,    FNULL,      HE1},
            {    "@2.Reset Printer        ",          " Reset printer ",    ok_menu2,    FNULL,      HE2},
            {    "@3.Eject Page           ",            " Eject paper ",    ok_menu3,    FNULL,      HE3},
            {    "@4.Printer Control Mode ",    " Switch control mode ",    ok_menu4,    FNULL,      HE4},
            {    "@5.Printer Test Pattern ",     " Perform test print ",    ok_menu5,    FNULL,      HE5},
            {    "@6.Print Settings       ", " Print current settings ",    ok_menu6,    FNULL,      HE6},
            {    "@7.Change Ink Cartridge ",  " Not necessary to send ",        NULL,    FNULL,        0},
            {    "@8.Clean Ink Head       ",       " Perform cleaning ",    ok_menu8,    FNULL,      HE8},
            {    "@9.Preset Status        ",    " Initialize settings ",    ok_menu9,    FNULL,      HE9},
            {                          NULL,         " Printer Action ",        NULL,    FNULL,        0}
};
static struct slug_list win3_menu_240[] = {

            {    "@1.Power Off            ",       " Turn off printer ",    ok_menu1,    FNULL,      HE1},
            {    "@2.Reset Printer        ",          " Reset printer ",    ok_menu2,    FNULL,      HE2},
            {    "@3.Eject Page           ",            " Eject paper ",    ok_menu3,    FNULL,      HE3},
            {    "@4.Printer Control Mode ",    " Switch control mode ",    ok_menu4,    FNULL,      HE4},
            {    "@5.Printer Test Pattern ",     " Perform test print ",    ok_menu5,    FNULL,      HE5},
            {    "@6.Print Settings       ", " Print current settings ",    ok_menu6,    FNULL,      HE6},
            {    "@7.Change Ink Cartridge ",  " Not necessary to send ",        NULL,    FNULL,        0},
            {    "@8.Clean Ink Head       ",       " Perform cleaning ",    ok_menu8,    FNULL,      HE8},
            {    "@9.Preset Status        ",    " Initialize settings ",    ok_menu9,    FNULL,      HE9},
            {    "@0.Dump Mode            ",    " Set/Reset Dump mode ",    ok_menu0,    FNULL,      HE0},
            {                          NULL,         " Printer Action ",        NULL,    FNULL,        0}
};
static struct slug_list win3_menu_80[] = {

            {    "@1.Power Off            ",       " Turn off printer ",    ok_menu1,    FNULL,      HE1},
            {    "@2.Reset Printer        ",          " Reset printer ",    ok_menu2,    FNULL,      HE2},
            {    "@3.Eject Page           ",            " Eject paper ",    ok_menu3,    FNULL,      HE3},
            {    "@4.Printer Control Mode ",    " Switch control mode ",    ok_menu4,    FNULL,      HE4},
            {    "@5.Printer Test Pattern ",     " Perform test print ",    ok_menu5_80, FNULL,      HE5},
            {    "@6.Print Settings       ", " Print current settings ",    ok_menu6,    FNULL,      HE6},
            {    "@7.Change Ink Cartridge ",      " Change print head ",    ok_menu7,    FNULL,      HE7},
            {    "@8.Clean Ink Head       ",       " Perform cleaning ",    ok_menu8_80, FNULL,      HE8},
            {    "@9.Preset Status        ",    " Initialize settings ",    ok_menu9_80, FNULL,      HE9},
            {                          NULL,         " Printer Action ",        NULL,    FNULL,        0}
};

#define    WINDOW_3_TITLE    "Printer Action"

//    Window 4 ---------------------------------------------------------------------------

#define    WINDOW_4_TITLE    "Parameter Settings"

#define    WINDOW_4_0                "    Parameter Setting Mode =%s\n"
#define    WINDOW_4_1         "@fd2h1[ Paper Selection           :###################]\n"
#define    WINDOW_4_2         "@fd2h7[ Print Mode                :###################]\n"
#define    WINDOW_4_3         "@fd2h1[ Smoothing                 :###################]\n"
#define    WINDOW_4_35        "@fd2h4[ Reduction                 :###################]\n"
#define    WINDOW_4_36       "@fd2h14[ Automatic Power On        :###################]\n"
#define    WINDOW_4_4        "@fd2h13[ Automatic Power Off       :###################]\n"
#define    WINDOW_4_5_B       "@fd2h1[ Font (BJ)                 :###################]\n"
#define    WINDOW_4_5_L       "@fd2h1[ Font (LQ)                 :###################]\n"
#define    WINDOW_4_6_B       "@fd2h3[ Code Page (BJ)            :###################]\n"
#define    WINDOW_4_6_L       "@fd2h3[ Code Page (LQ)            :###################]\n"
#define    WINDOW_4_7_B       "@fd2h6[ Page Length (BJ)          :###################]\n"
#define    WINDOW_4_7_L       "@fd2h6[ Page Length (LQ)          :###################]\n"
#define    WINDOW_4_7_L_80     "@fdh6[ Page Length (LQ)          :                ]\n"
#define    WINDOW_4_8_B       "@fd2h2[ Character Set (BJ)        :###################]\n"
#define    WINDOW_4_8_L       "@fd2h2[ Character Set (LQ)        :###################]\n"
#define    WINDOW_4_9_B       "@fd2h1[ Text Scale (BJ)           :###################]\n"
#define    WINDOW_4_9_L       "@fd2h1[ Text Scale (LQ)           :###################]\n"
#define    WINDOW_4_10       "@fd2h10[ Download Buffer           :###################]\n"
#define    WINDOW_4_11_B      "@fd2h1[ Automatic Line Feed (BJ)  :###################]\n"
#define    WINDOW_4_11_L      "@fd2h1[ Automatic Line Feed (LQ)  :###################]\n"
#define    WINDOW_4_12       "@fd2h13[ Automatic Carriage Return :###################]\n"
#define    WINDOW_4_12_C      "@fdh13[ Automatic Carriage Return :                ]\n"
#define    WINDOW_4_13       "@fd2h11[ Alternate Graphic Mode    :###################]\n"
#define    WINDOW_4_13_C      "@fdh11[ Alternate Graphic Mode    :                ]\n"
#define    WINDOW_4_14        "@fd2h1[ International Character   :###################]\n"
#define    WINDOW_4_14_C       "@fdh1[ International Character   :                ]\n"
#define    WINDOW_4_TOP_B     "@fd2h2[ Top Margin (BJ)           :###################]\n"
#define    WINDOW_4_TOP_L     "@fd2h2[ Top Margin (LQ)           :###################]\n"
#define    WINDOW_4_LOCK_B    "@fd2h8[ Font Lock (BJ)            :###################]\n"
#define    WINDOW_4_LOCK_L    "@fd2h8[ Font Lock (LQ)            :###################]\n"
#define    WINDOW_4_15        "@fd2h4[ Printer Port              :###################]\n"

#define    WINDOW_4_2_H    " Bubble Jet (BJ) mode setting only "
#define    WINDOW_4_3_H    " LQ emulation (LQ) mode setting only "
#define    WINDOW_4_4_H    " To switch this entry, you must change port "
#define    WINDOW_4_5_H    " Common setting (both LQ and BJ) "
#define    WINDOW_4_6_H    " Independent setting (LQ or BJ) "

#define    WINDOW_4_0_S0   " LQ emulation (LQ) "
#define    WINDOW_4_0_S0_N 19
#define    WINDOW_4_0_S1   " Bubble Jet (BJ) "
#define    WINDOW_4_0_S1_N 17

#define    WINDOW_4_1_S    " A4 , Letter , COM 10 Envelope , DL Envelope "
#define    WINDOW_4_1_80   " A4 , Letter "
#define    WINDOW_4_1_2500 " A4 , Letter , COM 10 Envelope , DL Envelope , B5 , Legal "
#define    WINDOW_4_2_S    " High Quality , High Speed , Fine "
#define    WINDOW_4_2_240  " High Quality , High Speed "
#define    WINDOW_4_3_S    " Enable , Disable "
#define    WINDOW_4_35_S   " Disable , Two-thirds , One-half "
#define    WINDOW_4_4_S    " Disable , 1 minute , 10 minutes , 30 minutes , 60 minutes "
#define    WINDOW_4_4_80   " Disable , 30 minutes "
#define    WINDOW_4_5_S    " Roman , Gothic , Courier , Prestige , Script "
#define    WINDOW_4_5_80   " Roman , Gothic , Courier , Prestige , Script , Draft "
#define    WINDOW_4_6_S    " 437 , 850 , 863 , 865 , 860 , 857 "
#define    WINDOW_4_6_240  " 437 , 850 , 863 , 865 , 860 , 852 "
#define    WINDOW_4_6_80   " 437 , 850 , 863 , 865 , 860 , 852 , 857 , 855, 864 , 869 "
#define    WINDOW_4_7_S0   " 11 inches , 12 inches , 22 inches "
#define    WINDOW_4_7_S1   " 11 inches , 12 inches "
#define    WINDOW_4_8_S0   " Italic , Graphics "
#define    WINDOW_4_8_S1   " Set 1 , Set 2 "
#define    WINDOW_4_11_S   " CR = CR + LF , CR = CR "
#define    WINDOW_4_12_S   " LF = LF + CR , LF = LF "
#define    WINDOW_4_14_S   " Japan , Norway , Denmark 2 , Spain 2 , Latin America , Korea , Legal , U.S.A. , France , Germany , U.K. , Denmark 1 , Sweden , Italy , Spain 1 "
#define    WINDOW_4_14_80  " Spain , U.S.A. , France , Germany , U.K. , Denmark , Sweden , Italy "
#define    WINDOW_4_15_S   " LPT1 , LPT2 "
#define    WINDOW_4_TOP_S  " 3.0 mm , 5.0 mm , 8.5 mm , 10.0 mm "

#define    BUBBLE_JET              'B'

#define    PAPER_ORDER              1
#define    PAPER_ORDER_3            3
#define    PAPER_A4                'A'
#define    PAPER_10_ENVELOPE       'C'
#define    PAPER_DL_ENVELOPE       'D'
#define    PAPER_LETTER            'L'
#define    PAPER_B5                'B'
#define    PAPER_LEGAL             'g'

#define    FONT_ORDER               1
#define    FONT_ROMAN              'R'
#define    FONT_GOTHIC             'G'
#define    FONT_PRESTIGE           'P'
#define    FONT_SCRIPT             'S'
#define    FONT_COURIER            'C'
#define    FONT_DRAFT              'D'

#define    CHAR_ENABLE             'E'

#define    CHAR_SET_ITALIC         'I'
#define    CHAR_SET_GRAPHIC        'G'

#define    REDUCTION_ORDER          1
#define    REDUCTION_DISABLE       'D'
#define    REDUCTION_TWO_THIRDS    'T'
#define    REDUCTION_ONE_HALF      'O'

//    Window 5 ---------------------------------------------------------------------------

#define    WINDOW_5_TITLE    "  Tab to Move among the windows  |  Alt + Highlight  or  Arrow key to Select  "

//    ------------------------------------------------------------------------------------

